<?php

/**
* @author Denik
* @site http://denik.od.ua
* @copyright 2009
*/

$plugin_info = array(
						'pi_name'			=> 'Insert new entry',
						'pi_version'		=> '1.0',
						'pi_author'			=> 'Denik',
						'pi_author_url'		=> 'http://irt.od.ua/',
						'pi_description'	=> 'Inserting a new entry of automatic mode',
						'pi_usage'			=> Insert_new_entry::usage()
					);

class Insert_new_entry {

    var $return_data;

    /** ----------------------------------------
    /**  Constructor
    /** ----------------------------------------*/

    function insert_new_entry($str = '')
    {
        global $TMPL, $PREFS, $REGX, $FNS, $SESS, $DB, $IN, $LOC;
		
		$return_data = "";
		
		// if == /if
		$eq = $TMPL->fetch_param('eq_var_1');
		if( $eq!==FALSE )
		{
			for( $i=2; $i<=9; $i++ )
			if( $TMPL->fetch_param('eq_var_'.$i)!==FALSE )
			{
				if( $TMPL->fetch_param('eq_var_'.$i)!=$eq ) return '';
			}
		}
		
		if( $run_if = $TMPL->fetch_param('run_if') )
		{
			// run_if = " '123'=='321' || ('1'=='1' && '2'=='454545') "
			$run_if = $TMPL->advanced_conditionals(LD.'if '.$run_if.RD.'true'.LD.'if:else'.RD.'false'.LD.'/if'.RD);
			if( $run_if=='false' ) return;
		}
		
		// Make data
		$site_id = array_search($TMPL->fetch_param('site'), $TMPL->sites);
		if( $site_id == FALSE || $site_id == NULL ) $site_id = $PREFS->ini('site_id');
		
		if ( $weblog = $TMPL->fetch_param('weblog') )
		{
	        $sql = $DB->query("SELECT weblog_id, field_group, cat_group FROM exp_weblogs WHERE site_id = '$site_id' AND `blog_name`='$weblog' LIMIT 0,1");
			if( $sql->num_rows == 0 ) return;
			$weblog = $sql->row['weblog_id'];
			$field_group = $sql->row['field_group'];
			$cat_group = $sql->row['cat_group'];
		}
		else return;
		
		if ( ! $title = $TMPL->fetch_param('title') ) return;
		$url_title = $TMPL->fetch_param('url_title')?$TMPL->fetch_param('url_title'):$title;
		$url_title = $this->url_title($url_title, $weblog, $site_id);
		
		$data = array();
		$data['site_id'] = $site_id;
		$data['weblog_id'] = $weblog;
		$data['author_id'] = $TMPL->fetch_param('author_id')?$TMPL->fetch_param('author_id'):$SESS->userdata['member_id'];
		$data['ip_address'] = $IN->IP;
		$data['versioning_enabled'] = $TMPL->fetch_param('versioning_enabled')?$TMPL->fetch_param('versioning_enabled'):'n';
		$data['year'] = date('Y', time());
		$data['month'] = date('m', time());
		$data['day'] = date('d', time());
		$data['edit_date'] = date("YmdHis");

		$data['entry_date'] = $LOC->convert_human_date_to_gmt($TMPL->fetch_param('entry_date'));
		if ( ! is_numeric($data['entry_date'])) 
        {
            $data['entry_date'] = $LOC->set_localized_time();
        }

        $data['expiration_date'] = $LOC->convert_human_date_to_gmt($TMPL->fetch_param('expiration_date'));
		if ( ! is_numeric($data['expiration_date'])) 
        {
            $data['expiration_date'] = 0;
        }

		$data['comment_expiration_date'] = '0';
		$data['sticky'] = 'n';
		$data['status'] = $TMPL->fetch_param('status')?$TMPL->fetch_param('status'):'open';
		$data['allow_comments'] = $TMPL->fetch_param('allow_comments')?$TMPL->fetch_param('allow_comments'):'n';
		$data['allow_trackbacks'] = $TMPL->fetch_param('allow_trackbacks')?$TMPL->fetch_param('allow_trackbacks'):'n';
		$data['forum_topic_id'] = 0;
		
		$data['title'] = $title;
		$data['url_title'] = $url_title;

		$DB->query($DB->insert_string('exp_weblog_titles', $data));
		$entry_id = $DB->insert_id;

		// costum fields:
		$data = array();
		$data['entry_id'] = $entry_id;
		$data['weblog_id'] = $weblog;
		$data['site_id'] = $site_id;
		
		// Load all fields
		$fields_id = array();
		$fields_ft = array();
		$query = $DB->query("SELECT field_id,field_name,field_fmt FROM exp_weblog_fields WHERE group_id='$field_group' AND site_id='$site_id'");
		foreach( $query->result as $row )
		{
			$fields_id[$row['field_name']] = $row['field_id'];
			$fields_ft[$row['field_name']] = $row['field_fmt'];
		}
		
		$custom_fields = explode('|', $TMPL->fetch_param('custom_fields'));
		foreach( $fields_id as $field_name=>$id )
		{
			if( in_array($field_name, $custom_fields) )
			{
				// Поле
				preg_match('/'.LD.'field_'.$field_name.'(.*?)'.RD.'(.*?)'.LD.SLASH.'field_'.$field_name.RD.'/s', $TMPL->tagdata, $tmp);
				if( !isset($tmp[2]) ) $tmp[2]="";
				$TMPL->tagdata = str_replace($tmp[0], "", $TMPL->tagdata); // del tag field
				$tmp = $tmp[2];
				$tmp = str_replace('&#47;', '/', $tmp);
				if (stristr($tmp, LD.'if'))
				{
					$tmp = $TMPL->segment_conditionals($tmp);
					$tmp = $TMPL->advanced_conditionals($tmp);
				}
				$data["field_id_{$id}"] = $tmp;
			}
			else $data["field_id_{$id}"] = "";
			$data["field_ft_{$id}"] = $fields_ft[$field_name];
		}
		
		$DB->query($DB->insert_string('exp_weblog_data', $data));

		// Назначать категории?
		if( $TMPL->fetch_param('categories') || $TMPL->fetch_param('categories_url_title') )
		{
			$categories = $TMPL->fetch_param('categories');
			$categories_url_title = $TMPL->fetch_param('categories_url_title');
			
			$sqlw = "group_id IN ('".str_replace('|', "','", $cat_group)."') ";
			if( $categories )
			{
				$categories = preg_replace('/[|&]+/', '|', $categories);
				if( substr($categories, 0,1)=='|' ) $categories = substr($categories, 1);
				if( substr($categories, -1)=='|' ) $categories = substr($categories, 0, -1);
				$sqlw .= "AND cat_id IN ('".str_replace('|', "','", $categories)."') ";
			}
			
			if( $categories_url_title )
			{
				$categories_url_title = preg_replace('/[|&]+/', '|', $categories_url_title);
				if( substr($categories_url_title, 0,1)=='|' ) $categories_url_title = substr($categories_url_title, 1);
				if( substr($categories_url_title, -1)=='|' ) $categories_url_title = substr($categories_url_title, 0, -1);
				$sqlw .= "AND cat_url_title IN ('".str_replace('|', "','", $categories_url_title)."') ";
			}

			$cats = $DB->query("SELECT cat_id FROM exp_categories WHERE $sqlw");
			foreach( $cats->result as $row )
			{
				$DB->query("INSERT INTO exp_category_posts SET entry_id='$entry_id',cat_id='{$row['cat_id']}'");
			}
		}
		
		// Return ?
		if( $TMPL->fetch_param('return') )
		{
			$url = str_replace('_ENTRY_ID_', $entry_id, $TMPL->fetch_param('return'));
			$url = $FNS->create_url( $url );
			$this_url = $FNS->create_url( str_replace($_SERVER['SCRIPT_NAME'], '', $_SERVER['REQUEST_URI']) );
			if( $url!=$this_url ) $FNS->redirect( $url );
		}
		
		// Обработка template
		$cfg = Array();
		
		$cfg["insert_entry_id"] = $entry_id;
		
		foreach( $cfg as $key=>$val )
		{
			$TMPL->tagdata = preg_replace('/'.LD.$key.RD.'/', $entry_id, $TMPL->tagdata);
		}

		$this->return_data = $TMPL->tagdata;
		$this->return_data = $FNS->prep_conditionals($this->return_data, $cfg);
    }
    /* END */

	function url_title($url_title, $weblog_id, $site_id)
	{
		GLOBAL $LANG, $DB, $PREFS, $REGX;
		
		$chaset = $PREFS->ini('charset')?$PREFS->ini('charset'):'utf-8';
		$url_title = iconv($chaset, 'cp1251', $url_title);
		
		$error = false;
		if (is_numeric($url_title)) $error = true;
		
		if( $url_title=='' ) $error = true;
		
		$tmp = "";
		for( $i=0; $i<strlen($url_title); $i++ )
		{
			$c = ord($url_title[$i]);
			
			if( $url_title[$i]=='_' || $url_title[$i]=='-' || $url_title[$i]==' ' ) {$tmp .= $url_title[$i]; continue;}
			if( $c >= 48 && $c <= 57 ) {$tmp .= $url_title[$i]; continue;}
			if( $c >= 97 && $c <= 122 ) {$tmp .= $url_title[$i]; continue;}
			
			if( $c == '192' ) {$tmp .= 'a'; continue;}
			if( $c == '193' ) {$tmp .= 'b'; continue;}
			if( $c == '194' ) {$tmp .= 'v'; continue;}
			if( $c == '195' ) {$tmp .= 'g'; continue;}
			if( $c == '196' ) {$tmp .= 'd'; continue;}
			if( $c == '197' ) {$tmp .= 'e'; continue;}
			if( $c == '198' ) {$tmp .= 'zh'; continue;}
			if( $c == '199' ) {$tmp .= 'z'; continue;}
			if( $c == '200' ) {$tmp .= 'i'; continue;}
			if( $c == '201' ) {$tmp .= 'j'; continue;}
			if( $c == '202' ) {$tmp .= 'k'; continue;}
			if( $c == '203' ) {$tmp .= 'l'; continue;}
			if( $c == '204' ) {$tmp .= 'm'; continue;}
			if( $c == '205' ) {$tmp .= 'n'; continue;}
			if( $c == '206' ) {$tmp .= 'o'; continue;}
			if( $c == '207' ) {$tmp .= 'p'; continue;}
			if( $c == '208' ) {$tmp .= 'r'; continue;}
			if( $c == '209' ) {$tmp .= 's'; continue;}
			if( $c == '210' ) {$tmp .= 't'; continue;}
			if( $c == '211' ) {$tmp .= 'u'; continue;}
			if( $c == '212' ) {$tmp .= 'f'; continue;}
			if( $c == '213' ) {$tmp .= 'h'; continue;}
			if( $c == '214' ) {$tmp .= 'c'; continue;}
			if( $c == '215' ) {$tmp .= 'ch'; continue;}
			if( $c == '216' ) {$tmp .= 'sh'; continue;}
			if( $c == '217' ) {$tmp .= 'sch'; continue;}
			if( $c == '219' ) {$tmp .= 'y'; continue;}			
			if( $c == '221' ) {$tmp .= 'e'; continue;}
			if( $c == '222' ) {$tmp .= 'yu'; continue;}
			if( $c == '223' ) {$tmp .= 'ya'; continue;}
			
			if( $c == '224' ) {$tmp .= 'a'; continue;}
			if( $c == '225' ) {$tmp .= 'b'; continue;}
			if( $c == '226' ) {$tmp .= 'v'; continue;}
			if( $c == '227' ) {$tmp .= 'g'; continue;}
			if( $c == '228' ) {$tmp .= 'd'; continue;}
			if( $c == '229' ) {$tmp .= 'e'; continue;}
			if( $c == '230' ) {$tmp .= 'zh'; continue;}
			if( $c == '231' ) {$tmp .= 'z'; continue;}
			if( $c == '232' ) {$tmp .= 'i'; continue;}
			if( $c == '233' ) {$tmp .= 'j'; continue;}
			if( $c == '234' ) {$tmp .= 'k'; continue;}
			if( $c == '235' ) {$tmp .= 'l'; continue;}
			if( $c == '236' ) {$tmp .= 'm'; continue;}
			if( $c == '237' ) {$tmp .= 'n'; continue;}
			if( $c == '238' ) {$tmp .= 'o'; continue;}
			if( $c == '239' ) {$tmp .= 'p'; continue;}
			if( $c == '240' ) {$tmp .= 'r'; continue;}
			if( $c == '241' ) {$tmp .= 's'; continue;}
			if( $c == '242' ) {$tmp .= 't'; continue;}
			if( $c == '243' ) {$tmp .= 'u'; continue;}
			if( $c == '244' ) {$tmp .= 'f'; continue;}
			if( $c == '245' ) {$tmp .= 'h'; continue;}
			if( $c == '246' ) {$tmp .= 'c'; continue;}
			if( $c == '247' ) {$tmp .= 'ch'; continue;}
			if( $c == '248' ) {$tmp .= 'sh'; continue;}
			if( $c == '249' ) {$tmp .= 'sch'; continue;}
			if( $c == '251' ) {$tmp .= 'y'; continue;}
			if( $c == '253' ) {$tmp .= 'e'; continue;}
			if( $c == '254' ) {$tmp .= 'yu'; continue;}
			if( $c == '255' ) {$tmp .= 'ya'; continue;}
		}
		$url_title = $tmp;
		if( $url_title == '' ) $error = true;
		
		$url_title = $REGX->create_url_title($url_title);
		
		// Unique
		$query = $DB->query("SELECT url_title FROM exp_weblog_titles WHERE url_title REGEXP '^{$url_title}[[:digit:]]*$' AND weblog_id = '{$weblog_id}' AND site_id = '{$site_id}' ORDER BY entry_id ASC");
		$titles = array();
		foreach($query->result AS $row)
		{
			$titles[] = $row['url_title'];
		}
		
		// nothing found? No problem!
		if (!count($titles)) return $url_title;
		
		$error = true;
		$unique = FALSE;
		$i = count($titles);
		
		while ($unique == FALSE)
		{
			$temp = ($i == 0) ? $url_title : $url_title.$i;
			$i++;
			
			if (!in_array($temp, $titles)) // BINGO!
			{
				$url_title = $temp;
				$unique = TRUE;
				$error = false;
			}
			
			if( $i >= 50 )
			{
				$unique = TRUE;
			}
		}
		
		if( $error )
		{
			return 'entry_'.time();
		}
		
		return $url_title;
	}
	
	/** ---------------------------------------
	/**  Plugin Usage
	/** ---------------------------------------*/

	function usage()
	{
	ob_start(); 
	?>
	Пример использования:
	{exp:insert_new_entry weblog="{my_weblog}" title="title" url_title="url_title" custom_fields="summary|body" run_if=" '{segment_4}'=='insert' "}
		{field_summary}Hello{/field_summary}
		{field_body}custom data{/field_body}
	{/exp:insert_new_entry}
	
	Параметры:
		- weblog = "my_weblog" - имя веблога, обязательный параметр
		- site = "default_site"
		- title = "Entry title"
		- url_title = "Entry_url_title" - если не передано, генерируется автоматически
		- return = "index"
			остарожно с этим параметром - при возвращении на ту же страницу, может возникнуть зацикливание.
			- можно так же использовать переменную _ENTRY_ID_ (id вставленной записи)
			  пример: return = "index/_ENTRY_ID_"
		- categories = "1|2|24.." - какие категории назначить записи
		- categories_url_title = "odessa|moskva.." - то же что и выше
		- status = "open"
		- author_id = "1"
		- versioning_enabled = "n" - сохранять версии записей?
		- entry_date = "2009-03-26 00:16" - дата публикации записи
		- expiration_date = "2009-06-26 00:16" - дата завершения записи
		- allow_comments = "n" - разрешить комментарии
		- allow_trackbacks = "n" - разрешить трекбеки
		- custom_fields = "summary|body" - поля которые будут искаться и обрабатываться в теле тега {field_body}...{/field_body}
		- run_if = " '{segment_3}'=='my_title' && '{segment_4}'!='FAILD' " - настраиваемый режим запуска, тег обработается только в случае удовлетворения заданного условия
		
	!! Важно. Т.к. данные настраиваемых полей работают только на "вход", то заключенные в них теги, так и будут передаваться тегами.
	Примечание: Conditionals(условия), внутри настраиваемых полей работают. 

	<?php
	$buffer = ob_get_contents();
	
	ob_end_clean(); 

	return $buffer;
	}
	/* END */


}
// END CLASS
?>